'ELECTRONIC CODE LOCK (codelock_08m2.bas)

'This electronic code lock uses a 4 digit (PIN) un-lock code 
'You should replace the default 1234 code with your own code.
'Do this by changing the four numbers in line 3 of the program 
'The valid numbers are 1 to 9,the number 0 should not be used 
'Alter the code before down-loading this program to the micro.
'The code lock operates a jaycar LA5077 fail secure door stike 


power_on:'----- press the enter button to turn the 5V power on
pause 2
b11 = 1: b12 = 2: b13 = 3: b14 = 4' (default unlock code)
let dirsC = %00010110 : let pinsC = %00000010
gosub de_bounce
pause 600
b1 = 0: b2 = 0: b3 = 0: b4 = 0
'goto code_1


code_1:'--------- enter first code number after 1st LED flash
gosub flash_led  
for b0 = 0 to 20
if pinC.3 = 0 then: b0 = 0: inc b1: gosub de_bounce: endif
pause 50
next b0
'goto code_2


code_2:'--------- enter second code number after 2nd LED flash
gosub flash_led  
for b0 = 0 to 20
if pinC.3 = 0 then: b0 = 0: inc b2: gosub de_bounce: endif
pause 50
next b0
'goto code_3


code_3:'--------- enter third code number after 3rd LED flash
gosub flash_led  
for b0 = 0 to 20
if pinC.3 = 0 then: b0 = 0: inc b3: gosub de_bounce: endif
pause 50
next b0
'goto code_4


code_4:'--------- enter forth code number after 4th LED flash
gosub flash_led  
for b0 = 0 to 20
if pinC.3 = 0 then: b0 = 0: inc b4: gosub de_bounce: endif
pause 50
next b0
goto test_codes


de_bounce:'----- waiting for the enter button to be released
high C.4
pause 50
if pinC.3 = 0 then: goto de_bounce: endif
low C.4
return


flash_led:'----- code to flash the LED for 400ms when required
high C.4
pause 400
low C.4
return


test_codes:'---- the default and entered un-lock codes must match
pause 2 
if b1=b11 and b2=b12 and b3=b13 and b4=b14 then: b8=10 else b8=0:endif
if b8 = 0 then: goto code_fail: endif
if b8 = 10 then:goto code_pass: endif


code_fail:'------ LED turns on for 3sec to show code was wrong
high C.4: 
pause 3000
low C.4
goto power_off


code_pass:'------ flash LED and energise door strike for 8sec   
high C.2
for b0 = 0 to 9
high C.4: 
pause 400
low C.4
pause 400
next b0
low C.2
goto power_off


power_off:'------ turn 5V power off and return to stand-by mode
low C.1
sleep 4



'Definition of Variables

'b0 and b8 = temporary variable
'b1 to b4 = entered unlock codes 
'b11 to b14 = saved unlock codes 
